﻿601,100
602,"load_actuals_in_usgaap_recon"
562,"ODBC"
586,"RRIWD"
585,"RRIWD"
564,
565,"vr`mRu3[wKaRP6irl`Yim0aVO9bpeV\ZYTF``EhQ>UnX=8GI:w3AhgsXR6Y3O50Xwz:1GzchGP2kmGYnFQ\Z7K^3OGDmZxv7u=iS64tuy:K2?Pt\LrhRa_jKu1v=]C8sYB<ab>O7DV12F>Oyw;PqbfLalJHX`5Qo^8o8lTNbH<^AaH6ot8PatFkgda09X4v=s=mv4@Sg"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,20
select
'USGAAP' as LAYER,
'AAA'||substr(char(period_id),1,4) as case,
AL5.tax_lvl2_desc as acct,
AL2.CTRYNUM as tbctry,
entity_code,
Al1.currency_type as currency,
sum(AL1.AMT_USD) as amt_usd,
sum(AL1.AMT_LOC) as amt_loc
FROM TAXWH.TOTALBRANCH_FT_V_CY AL1,
TAXWH.COUNTRY_DM_V AL2,
TAXWH.legal_entity_DM_V AL3,
TAXWH.ACCOUNT_DM_V AL5
WHERE AL1.ENTITY_ID=AL3.ENTITY_ID
AND AL1.ACCT_ID=AL5.ACCOUNT_ID
and AL1.tbcty_ID = AL2.country_id
and entity_code not like 'STA%'
group by tax_lvl2_desc,'AAA'||substr(char(period_id),1,4),entity_code,AL2.ctrynum,Al1.currency_type
having ( sum(AL1.AMT_USD) <> 0 OR sum(AL1.AMT_LOC) <> 0 )
order by 1,2,3,4,5,6
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,0
561,0
590,0
637,0
577,8
vLayer
vCase
vAcct
vTbcty
vEntity_code
vCrncy
vAmtUSD
vAmtLOC
578,8
2
2
2
2
2
2
1
1
579,8
1
2
3
4
5
6
7
8
580,8
0
0
0
0
0
0
0
0
581,8
0
0
0
0
0
0
0
0
582,9
VarType=32ColType=827
VarType=32ColType=827
VarType=32ColType=827
VarType=32ColType=827
VarType=32ColType=827
VarType=32ColType=827
VarType=33ColType=827
VarType=33ColType=827
VarName=vEntityCtryVarType=33ColType=827VarFormula=vEntityCtry=vEntity_code |'-'| vTbcty;:VarFormulaDestination=BOTH
603,0
572,18

#****Begin: Generated Statements***
#****End: Generated Statements****

# Retrieve process parameters from control cube
sControl = 'cn_control';
#sLoggingDir = CellGetS(sControl, 'logging_directory','current');

DatasourceNameForServer = CellGetS(sControl,'DB2_Source','current');
DatasourceNameForClient = CellGetS(sControl,'DB2_Source','current');
DatasourcePassword=CellGetS(sControl,'DB2_PW','current');
DatasourceUserName=CellGetS(sControl,'DB2_Userid','current');


sCube = 'in_usgaap_recon';
index = 1;

CubeSetLogChanges(sCube, 0);
573,20

#****Begin: Generated Statements***
vEntityCtry=vEntity_code |'-'| vTbcty;
#****End: Generated Statements****

if (DIMIX('tbcty', vTbCty)=0);
DimensionElementComponentAdd('tbcty', 'Unknown Countries', vTbcty, 1);
endif;


if (DIMIX('account', vAcct)=0);
DimensionElementComponentAdd('account', 'Unknown Accounts', vAcct, 1);
endif;


if (DIMIX('legal_entity_base_flat', vEntityCtry)=0);
DimensionElementComponentAdd('legal_entity_base_flat', 'Unknown Legal Entities',vEntityCtry, 1);
endif;


574,41

#****Begin: Generated Statements***
vEntityCtry=vEntity_code |'-'| vTbcty;
#****End: Generated Statements****

sForm='200c';

## Load USD Data

sMeasureUSD = 'amount';

vAcctVar=if(vAcct@='Net Income for Year','Net Income for the Year',vAcct);

if (vEntity_Code @<> '');
oldValue = CellGetN(sCube, vLayer,vCase,vAcctVar,vTbcty,vEntityCtry,sForm,sMeasureUSD);

newValue = oldValue+vAmtUSD;

CellPutN(newValue, sCube, vLayer,vCase,vAcctVar,vTbcty,vEntityCtry,sForm,sMeasureUSD);
endif;

### End Load USD Data


## Load Local Data

sMeasureLOC = 'amount_local';

vAcctVar=if(vAcct@='Net Income for Year','Net Income for the Year',vAcct);

if (vEntity_Code @<> '');
oldValue = CellGetN(sCube, vLayer,vCase,vAcctVar,vTbcty,vEntityCtry,sForm,sMeasureLOC);

newValue = oldValue+vAmtLOC;

CellPutN(newValue, sCube, vLayer,vCase,vAcctVar,vTbcty,vEntityCtry,sForm,sMeasureLOC);
endif;

### End Load Local Data


575,5

#****Begin: Generated Statements***
#****End: Generated Statements****

CubeSetLogChanges(sCube, 1);
576,CubeAction=1511DataAction=1503CubeLogChanges=0
930,0
638,1
804,0
1217,0
900,
901,
902,
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
